import sys

from PyQt5.QtCore import pyqtProperty, pyqtSignal, pyqtSlot, QObject


# This is the type that will be registered with QML.  It must be a
# sub-class of QObject.
class Contacts(QObject):
    def __init__(self, parent=None):
        super().__init__(parent)

        # Initialise the value of the properties.
        self._name = 'Not set'
            
        
    # All signals
    nameChanged = pyqtSignal()


    # Define the getter of the 'name' property.  The C++ type of the
    # property is QString which Python will convert to and from a string.
    @pyqtProperty('QString', notify=nameChanged)
    def name(self):
        return self._name

    # Define the setter of the 'name' property.
    @name.setter
    def name(self, name):
        print('name changed')
        if self._name != name:
            self._name = name
            self.nameChanged.emit()
            
    @pyqtSlot()
    def prev_contact(self):
        print('handle prev contact')
        self.name = 'prev name'

    @pyqtSlot()
    def next_contact(self):
        print('handle next contact')
        self.name = 'next name'
        

